% function [proposedMembership, trial_E, oldCluster, newCluster, randomized2, O_prototypes1, C_prototypes1, ClusterCount1, sumInCluster1, frequencyInCluster1]=select_object(myData1, myData2, assignment, CCount, SumClust, Oproto, Cproto, freqClust, k_num, gWeight);
% 
% Generate proposed cluster state
%
% NumericalData - Numerical data
% CategoricalData - Categorical data
% membership - Current state of clustership

% trial_E - New value of cost function 
% proposedMembership - New proposed State of clustership


function [proposedMembership, trial_E, oldCluster, newCluster, randomized2, O_prototypes1A, O_prototypes1C, C_prototypes1, ClusterCount1, sumInCluster1A, sumInCluster1C, frequencyInCluster1]=select_object(myData0, myData1, myData2, assignment, CCount, SumClustA, SumClustC, OprotoA, OprotoC, Cproto, freqClust, k_num, aWeight, bWeight, gWeight)
ClusterCount1 = CCount;
sumInCluster1A = SumClustA;
sumInCluster1C = SumClustC;
O_prototypes1A = OprotoA;
O_prototypes1C = OprotoC;
C_prototypes1 = Cproto;
frequencyInCluster1 = freqClust;
NumericalData0 = myData0;
NumericalData1 = myData1;
CategoricalData1 = myData2;
[theNumA_n, theNumA_p] = size(NumericalData0);
[theNumC_n, theNumC_p] = size(NumericalData1);
[theCat_n, theCat_p] = size(CategoricalData1);
%%%%%%%%Update prototypes%%%%%%%%%%%

sumInCluster1A = zeros(k_num,theNumA_p);
    for k = 1:k_num
       
        for j = 1:theNumA_p 
          %ClusterCount1(k) = 0;
          myFixedCounter = 0;
           for i = 1:theNumA_n
               %sumInCluster(k,j) = 0;
               if assignment(i) == k 
                    sumInCluster1A(k,j) = sumInCluster1A(k,j) + NumericalData0(i,j);
                   % ClusterCount1(k) = ClusterCount1(k)+1; 
                    myFixedCounter = myFixedCounter + 1;
               end
          end
          %O_prototypes1A(k,j) = sumInCluster1A(k,j)/ClusterCount1(k);
          O_prototypes1A(k,j) = sumInCluster1A(k,j)/myFixedCounter;
        end
    end
   
  sumInCluster1C = zeros(k_num,theNumC_p);
    for k = 1:k_num
       
        for j = 1:theNumC_p 
          %ClusterCount1(k) = 0;
          myFixedCounter = 0;
           for i = 1:theNumC_n
               %sumInCluster(k,j) = 0;
               if assignment(i) == k 
                    sumInCluster1C(k,j) = sumInCluster1C(k,j) + NumericalData1(i,j);
                    %ClusterCount1(k) = ClusterCount1(k)+1; 
                    myFixedCounter = myFixedCounter + 1; 
               end
          end
          %O_prototypes1C(k,j) = sumInCluster1C(k,j)/ClusterCount1(k);
          O_prototypes1C(k,j) = sumInCluster1C(k,j)/myFixedCounter;
        end
    end
    
    %sss = find(Clustership == Cluster);
    %[sss_n, sss_p] = size(sss);
   for k = 1:k_num
    
        for j = 1:theCat_p
            Cat_jj = unique(CategoricalData1(:,j));
            [theCat_jj_n, theCat_jj_p] = size(Cat_jj);
            for z = 1:theCat_jj_n
                frequencyInCluster1(k,j,z) = 0;
                for i= 1:theCat_n
                    %sumInCluster(k,j) = 0;
                    if assignment(i) == k 
                        if strcmp(CategoricalData1(i,j), Cat_jj(z)) == 1 
                            frequencyInCluster1(k,j,z) = frequencyInCluster1(k,j,z) + 1;
                        end
                    end
                end
            end
            
%             counterU = 0;
% 			[myB,myI,myJ] = UNIQUE(frequencyInCluster1(k, j,:));
% 			%max(B)
% 			[myY,myQ] = max(myB);
% 			[myM,myN] = size(myJ);
% 			for i = 1:myN
%                 if myJ(i) == myQ
%                     counterU = counterU + 1;
%                 end
% 			end
% 			if counterU == 1
%                 [catMaxNum,catMaxIndex] = max(frequencyInCluster1(k, j,:));
%                 C_prototypes1(k,j) = Cat_jj(catMaxIndex);
%                 
% 			else
%                 [myII,myJJ] = find(myJ==myQ);
%                 myRandomized = resamp(1,myJJ,1);
%                 C_prototypes1(k,j) = Cat_jj(myRandomized);
% 			end
            [catMaxNum,catMaxIndex] = max(frequencyInCluster1(k, j,:));
            C_prototypes1(k,j) = Cat_jj(catMaxIndex);
            
        end
	end 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%membership = assignment;

proposedMembership = [];

theMaxClustNum = max(assignment);
FFF = 0;
while FFF ~= 1
    randomized2 = resamp(1,1:theNumA_n);
    oldCluster = assignment(randomized2);
    newCluster = resamp(1,1:k_num);
   if ClusterCount1(oldCluster) ~= 1 && newCluster ~= oldCluster %&& ClusterCount(oldCluster) ~= 0
       %if newCluster ~= oldCluster
       
       FFF = 1;
            %  end
   end
end

proposedMembership = assignment;

proposedMembership(randomized2) = newCluster;
ClusterCount1(newCluster) = ClusterCount1(newCluster) + 1;
ClusterCount1(oldCluster) = ClusterCount1(oldCluster) - 1;
for j = 1:theNumA_p
    sumInCluster1A(newCluster,j) = sumInCluster1A(newCluster,j) + NumericalData0(randomized2,j);
    sumInCluster1A(oldCluster,j) = sumInCluster1A(oldCluster,j) - NumericalData0(randomized2,j);
    O_prototypes1A(newCluster,j) = sumInCluster1A(newCluster,j)/ClusterCount1(newCluster);
    O_prototypes1A(oldCluster,j) = sumInCluster1A(oldCluster,j)/ClusterCount1(oldCluster);
end
for j = 1:theNumC_p
    sumInCluster1C(newCluster,j) = sumInCluster1C(newCluster,j) + NumericalData1(randomized2,j);
    sumInCluster1C(oldCluster,j) = sumInCluster1C(oldCluster,j) - NumericalData1(randomized2,j);
    O_prototypes1C(newCluster,j) = sumInCluster1C(newCluster,j)/ClusterCount1(newCluster);
    O_prototypes1C(oldCluster,j) = sumInCluster1C(oldCluster,j)/ClusterCount1(oldCluster);
end
for j = 1:theCat_p
    Cat_jj = unique(CategoricalData1(:,j));
    [theCat_jj_n, theCat_jj_p] = size(Cat_jj);

    for z = 1:theCat_jj_n
        if strcmp(CategoricalData1(randomized2,j), Cat_jj(z)) == 1 
            frequencyInCluster1(newCluster,j,z) = frequencyInCluster1(newCluster,j,z) + 1;
            frequencyInCluster1(oldCluster,j,z) = frequencyInCluster1(oldCluster,j,z) - 1;
            [catNewMaxNum,catNewMaxIndex] = max(frequencyInCluster1(newCluster, j,:));
            [catOldMaxNum,catOldMaxIndex] = max(frequencyInCluster1(oldCluster, j,:));
            C_prototypes1(newCluster,j) = Cat_jj(catNewMaxIndex);
            C_prototypes1(oldCluster,j) = Cat_jj(catOldMaxIndex);
        end
    end
end
Distance2 = zeros(theNumA_n,k_num);
for i = 1:theNumA_n
    for k = 1:k_num
    
        if proposedMembership(i) == k
            NumDistA = distance(NumericalData0(i,:), O_prototypes1A(k,:), theNumA_p);
            NumDistC = distance(NumericalData1(i,:), O_prototypes1C(k,:), theNumC_p);
	        CatDist = sigma(CategoricalData1(i,:), C_prototypes1(k,:), theCat_p);
            Distance2(i,k) = aWeight*NumDistA + bWeight*NumDistC + gWeight*CatDist;
        end
    end
end
preTrialCostFunction_P = sum(Distance2);
trial_E = sum(preTrialCostFunction_P);

   
   