% function [State, E2, p1, p2, CC, SIC, FIC]=metropolis(ND, CD, X, T, E, N_Steps, CC, SIC, O_proto, C_proto, FIC, cNum, gammaW);
% 
% Metropolis Algorithm
%
% ND - Numerical data
% CD - Categorical data
% X - Clustership of objects
% E - Current Value of  cost function
% T = temperature
% N_Steps - steps of the Metropolis algorithm
% 
% current_State - Current State of clustership


function [State, E2, p0, p1, p2, CC, SICA, SICC, FIC]=metropolis(NDA, NDC, CD, X, T, E, N_Steps, CC, SICA, SICC, O_protoA, O_protoC, C_proto, FIC, cNum, alphaW,  betaW, gammaW)
current_State = X;
numberDataA = NDA;
numberDataC = NDC;
catergoricalData = CD;
Temp = T;
cost = E;
p0 = O_protoA;
p1 = O_protoC;
p2 = C_proto;

for i = 1:N_Steps
    myCounter10 = 0;
    [current_State, cost, p0, p1, p2, CC, SICA, SICC, FIC] = next_state(numberDataA, numberDataC, catergoricalData, Temp, cost, current_State, CC, SICA, SICC, p0, p1, p2, FIC, cNum, alphaW, betaW, gammaW, myCounter10);
    i;
end
State = current_State;
E2 = cost;